summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorPádraig Brady <P@draigBrady.com>2014-10-11 10:06:48 +0100
committerPádraig Brady <P@draigBrady.com>2015-06-24 17:03:35 +0100
commitfc6825b231b43c12738fb65a9309cdecb67f6833 (patch)
tree50bb0b64a18e3a6b636ecc11f8d41b5778488d45 /tests
parent53883af063d13a628520615e12705bc6f3a549ec (diff)
downloadcoreutils-fc6825b231b43c12738fb65a9309cdecb67f6833.tar.xz
seq: support inf last item more generally/efficiently
* src/seq.c (main): Call seq_fast for infinite last value. This implicitly avoids format conversion on the 999999 -> 1000000 transition. * src/seq.c (seq_fast): Generalize the buffer handling, and adjust to handle the "inf" last value specifics. * tests/misc/seq-precision.sh: A new test. * tests/local.mk: Reference the new test.
Diffstat (limited to 'tests')
-rw-r--r--tests/local.mk1
-rwxr-xr-xtests/misc/seq-precision.sh37
2 files changed, 38 insertions, 0 deletions
diff --git a/tests/local.mk b/tests/local.mk
index 7b8c91edf..d60f6cfec 100644
--- a/tests/local.mk
+++ b/tests/local.mk
@@ -236,6 +236,7 @@ all_tests = \
tests/misc/test.pl \
tests/misc/seq.pl \
tests/misc/seq-long-double.sh \
+ tests/misc/seq-precision.sh \
tests/misc/head.pl \
tests/misc/head-elide-tail.pl \
tests/tail-2/tail-n0f.sh \
diff --git a/tests/misc/seq-precision.sh b/tests/misc/seq-precision.sh
new file mode 100755
index 000000000..9ba601446
--- /dev/null
+++ b/tests/misc/seq-precision.sh
@@ -0,0 +1,37 @@
+#!/bin/sh
+# Test for output with appropriate precision
+
+# Copyright (C) 2015 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ seq
+
+# Integer only. Before v8.24 this would switch output format
+seq 999999 inf | head -n2 > out || fail=1
+printf "%s\n" 999999 1000000 > exp || framework_failure_
+compare exp out || fail=1
+
+# Excercise buffer handling in non floating point output
+for i in $(seq 100); do
+ n1="$(printf '%*s' $i '' | tr ' ' 9)"
+ n2="1$(echo $n1 | tr 9 0)"
+
+ seq $n1 $n2 > out || fail=1
+ printf "%s\n" "$n1" "$n2" > exp || framework_failure_
+ compare exp out || fail=1
+done
+
+Exit $fail